<?php

App::uses('AppComponent', 'Controller/Component');

class SignupsComponent extends AppComponent {

	/**
	 * Component startup - check for the form being submitted
	 *
	 */
	public function startup(Controller $Controller) {
		if ($this->_controller->request->is('post') && ! empty($this->_controller->request->data['Newsletter'])) {
			$signupData = $this->_controller->request->data['Newsletter'];

			// check for extras
			$extraFields = Configure::read('EvNewsletterSignups.extraFields');
			if (! empty($signupData['Signup']['extras']) && ! empty($extraFields)) {
				$signupData['Signup']['extras'] = json_encode($signupData['Signup']['extras']);
			}

			$Signup = EvClassRegistry::init('EvNewsletterSignups.Signup');

			if ($Signup->save($signupData)) {
				$this->_controller->Flash->success(
					Configure::read('EvNewsletterSignups.flashMessage.success'),
					array(
						'key' => 'newsletter-flash'
					)
				);

				unset($this->_controller->request->data['Newsletter']);
			} else {
				$this->_controller->Flash->fail(
					Configure::read('EvNewsletterSignups.flashMessage.fail'),
					array(
						'key' => 'newsletter-flash'
					)
				);
			}
		}
	}

}
